<?php
session_start();
?>
<h2>Decode submitted Form</h2>

<div style="padding: 0.500em;">

<?php

class jsEncode {
 
	/**
	* Encodes or decodes string according to key
	* 
	* @access public
	* @param mixed $str
	* @param mixed $decodeKey
	* @return string
	*/

	public function encodeString($str,$decodeKey) {
		$result = "";
		for($i = 0;$i < strlen($str);$i++) {
			$a = $this->_getCharcode($str,$i);
			$b = $a ^ $decodeKey;
			$result .= $this->_fromCharCode($b);
		}
		return $result;
	}
    
	/**
	* PHP replacement for JavaScript charCodeAt.
	* 
	* @access private
	* @param mixed $str
	* @param mixed $i
	* @return string
	*/
	private function _getCharcode($str,$i) {
		return $this->_uniord(substr($str, $i, 1));
	}

	/**
	* Gets character from code.
	* 
	* @access private
	* @return string
	*/
	private function _fromCharCode(){
		$output = '';
		$chars = func_get_args();
		foreach($chars as $char){
			$output .= chr((int) $char);
		}
		return $output;
	}

	/**
	* Multi byte ord function.
	* 
	* @access private
	* @param mixed $c
	* @return mixed
	*/
	private function _uniord($c) {
		$h = ord($c{0});
		if ($h <= 0x7F) {
			return $h;
		} else if ($h < 0xC2) {
			return false;
		} else if ($h <= 0xDF) {
			return ($h & 0x1F) << 6 | (ord($c{1}) & 0x3F);
		} else if ($h <= 0xEF) {
			return ($h & 0x0F) << 12 | (ord($c{1}) & 0x3F) << 6 | (ord($c{2}) & 0x3F);
		} else if ($h <= 0xF4) {
			return ($h & 0x0F) << 18 | (ord($c{1}) & 0x3F) << 12 | (ord($c{2}) & 0x3F) << 6 | (ord($c{3}) & 0x3F);
		} else {
			return false;
		}
	}
}

echo '<pre>';
print_r($_POST);
echo '</pre>' . PHP_EOL;

$d = new jsEncode();

$b64n = $_POST['b64n'];
$b64p = $_POST['b64p'];
$key    = $_SESSION['key'] / 2;

$user = urldecode( $d->encodeString( base64_decode( $b64n ), $key ) );
$pass = urldecode( $d->encodeString( base64_decode( $b64p ), $key ) );

echo '<pre><p>php decoded base64 ($b64n) : ' .
	 $user . PHP_EOL;
echo 'php decoded base64 ($b64p) : ' .
	 $pass .
	'</p></pre>' . PHP_EOL;

include ('connect.php');

$db_result = TRUE;

if (mysqli_connect_errno()) {

	$db_result = FALSE;
	$db_msg = "Connect failed: " . mysqli_connect_error();

}

// Or put the above code in a separate file and use include
// include '/path/to/connect_db.php';

if ( $db_result === TRUE ) {

	$username = $db->real_escape_string( $user );
	$db->set_charset("utf8");
	$query = "SELECT * FROM users WHERE login_name = '" . $username . "';";

	if ( $result = $db->query( $query ) ) {

		if ( $result->num_rows > 0 ) {
		?>

<table>

<?php
			while ( $row = $result->fetch_object() ) {
				$passOk = ( md5( $pass ) === $row->password ? 'valid' : '<span style="color:red;font-weight:bold;">invalid<span>' );
?>
<tr><td>First name</td><td><?php echo $row->first_name; ?></td></tr>
<tr><td>Last name</td><td><?php echo $row->last_name; ?></td></tr>
<tr><td>Login name</td><td><?php echo $row->login_name; ?></td></tr>
<tr><td>Password is</td><td><?php echo $passOk; ?></td></tr>
<?php
			}
?>

</table>
<?php
		} else {

			echo '<table>
			<tr><td>
			<p>No records found.</p>
			</td></tr>
			</table>' . PHP_EOL;

		}

		$result->close();

	} else {

		echo '<p>No result. Probably because the connection failed or the query was wrong.</p>' . PHP_EOL;

	}

} else {

	echo '<p>no connection made.</p>' . PHP_EOL;
	echo '<p>' . $db_msg . '</p>' . PHP_EOL;

}

$db->close();
?>

<form action="encode.php">
<p><input type="submit" value="Again" autofocus /></p>
</form>

</div>